// Copyright (c) 2021, Pedro Quaresma <pedro@mat.uc.pt>

#include <iostream>
#include <cstdio>
#include <cstring> // permite a utilizao de funcoes que manipulam c-strings 

#include "cifrasSubstituicao.hpp"


using namespace std;

int main(int argc, char *argv[]){
  
  //fl -> o ficheiro de leitura 
  //fe -> o ficheiro de escrita
    
  FILE *fl,*fe;
  
  if(argc!=4){//validar os valores de entrada 
    cout << "\nUtilizaao: desencriptarvig  nome_ficheiro_entrada palavra_chave nome_ficheiro_saida\n\n";
    return(1);
  }
  
  
  //declaracao das variaveis
  
  char *menscifrada, *mensdecifrada;
  int compchave,tamanhodachave;
 
  //comprimento da palavrachave
  compchave=strlen(argv[2]);
  
  char palavrachav[compchave];
  int wordkey[compchave];
  int ch[compchave],m[compchave];


  // Objecto do tipo Cifras de Substituio
  CifrasSubstituicao cifraVig;
  
  //fazer a copia do ficheiro de entrada
  menscifrada = argv[1];
  
  
  //fazer uma copia do conteudo do argv[2] para a palavrachav  
  strcpy(palavrachav,argv[2]);
  
  //converter a palavra-chave para minuscula
  cifraVig.toMinuscula(palavrachav);
   
  //chamar a funcao converterpalavrachave
  cifraVig.converterPalavraChave(palavrachav,wordkey);

  //fazer a copia do ficheiro de saida
  mensdecifrada = argv[3];
  
  //abrir o ficheiro
  fl = fopen(menscifrada,"r");
  
  //verificar se o ficheiro foi aberto ou nao
  //caso contrario o programa termina
  if(fl == NULL){
    cout << "Impossivel abrir o ficheiro " << argv[1] << endl;
    return(2);
  }
  
  //Abrir o ficheiro para escrever a mensagem cifrada
  if((fe = fopen(mensdecifrada,"w"))==NULL){
    cout << "Impossivel criar o ficheiro " << mensdecifrada << endl;
    return(3);
  }
  
  int i=0; 
  while((ch[i] = fgetc(fl)) != EOF){
    //verificar se o bloco mensagem ja esta completo
    if(i==compchave-1){
      cifraVig.desencriptarVig(ch,wordkey,m,i);
      cifraVig.escreverBloco(fe,i,m);
      i=0;
    }
    else
      i++;
  }
  cifraVig.desencriptarVig(ch,wordkey,m,i);
  cifraVig.escreverBloco(fe,i-1,m);
  
  //Fechar os ficheiros
  fclose(fl);
  fclose(fe);
  
  return(0);
  
}
