// Copyright (c) 2021, Pedro Quaresma <pedro@mat.uc.pt>

#include <iostream>
#include <cstdio>
#include <cstring> // permite a utilizao de funcoes que manipulam c-strings 

#include "cifrasSubstituicao.hpp"


using namespace std;

int main(int argc, char *argv[]){
  
  //fl -> o ficheiro de leitura 
  //fe -> o ficheiro de escrita 
  
  FILE *fl,*fe;
  
  if(argc!=4){//validar os valores de entrada 
    cout << "\nUtilizaao: encriptarVig  nome_ficheiro_entrada palavra_chave nome_ficheiro_saida\n\n";
    return(1);
  }
  
  //Declaracao das variaveis
  char *mensnormal, *menscifrada;
  int compchave,compkey;

  //comprimento da palavrachave
  compchave=strlen(argv[2]);
  
  char palavrachav[compchave];
  int wordkey[compchave];
  int ch[compchave],c[compchave];
  char caracter[1];

  // Objecto do tipo Cifras de Vigenre
  CifrasSubstituicao cifraVig;
    
  // fazer a cpia do ficheiro de entrada
  mensnormal = argv[1];
  
  // fazer uma cpia do contedo do argv[2] para a palavrachav
  strcpy(palavrachav,argv[2]);
  
  // converter a palavra-chave para minscula
  cifraVig.toMinuscula(palavrachav);
   
  // Chamar a funo converterPalavraChave 
  cifraVig.converterPalavraChave(palavrachav,wordkey);
  
    
  // Fazer a copia do ficheiro de saida
  menscifrada = argv[3];
  
  
  // Abrir o ficheiro para a leitura
  fl = fopen(mensnormal,"r");
  
  //verificar se o ficheiro foi aberto ou nao
  //caso contrario o programa termina
  if(fl==NULL){
    cout << "Impossivel abrir o ficheiro " << argv[1] << endl;
    return(2);
  }
  
  
  // Abrir o ficheiro para escrever a mensagem cifrada
  if((fe = fopen(menscifrada,"w"))==NULL){
    cout << "Impossivel criar o ficheiro " << menscifrada << endl;
    return(3);
  }

  //Aplicar cifra de Vigenre
  int i=0;
  while((ch[i]=fgetc(fl))!=EOF){
    //verificar se o bloco mensagem j est completo
    if(i == compchave-1){
      cifraVig.encriptarVig(ch,wordkey,c,i);
      cifraVig.escreverBloco(fe,i,c);
      i=0;
    }
    else
      i++;
  }
  cifraVig.encriptarVig(ch,wordkey,c,i);
  cifraVig.escreverBloco(fe,i-1,c);
  
  
  //Fechar os ficheiros
  fclose(fl);
  fclose(fe);
  
  return(0);
  
}
